/*---------------------------------------------------------------------------------
	$Id: interrupts.c,v 1.8 2006/02/21 00:12:35 wntrmute Exp $

	Copyright (C) 2005
		Dave Murphy (WinterMute)

	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any
	damages arising from the use of this software.

	Permission is granted to anyone to use this software for any
	purpose, including commercial applications, and to alter it and
	redistribute it freely, subject to the following restrictions:

	1.	The origin of this software must not be misrepresented; you
		must not claim that you wrote the original software. If you use
		this software in a product, an acknowledgment in the product
		documentation would be appreciated but is not required.
	2.	Altered source versions must be plainly marked as such, and
		must not be misrepresented as being the original software.
	3.	This notice may not be removed or altered from any source
		distribution.

	$Log: interrupts.c,v $
	Revision 1.8  2006/02/21 00:12:35  wntrmute
	clear interrupts and enable REG_IME in irqInit
	
	Revision 1.7  2005/12/12 13:03:29  wntrmute
	set/clear LCD interrupts in irqEnable/Disable
	
	Revision 1.6  2005/11/07 01:11:08  wntrmute
	more doxygen
	moved IntrMain declaration to C file
	
	Revision 1.5  2005/09/20 05:00:24  wntrmute
	use new register definitions
	
	Revision 1.4  2005/09/04 16:28:04  wntrmute
	place irqTable in ewram

	Revision 1.3  2005/09/03 17:09:35  wntrmute
	added interworking aware interrupt dispatcher


---------------------------------------------------------------------------------*/

#include <nds/interrupts.h>
#include <nds/system.h>

void _IntrMain();	// Prototype for assembly interrupt dispatcher

//---------------------------------------------------------------------------------
void _irqDummy(void) {}
//---------------------------------------------------------------------------------

// Placing the irqTable in dtcm fails, currently no idea why.

//#ifdef ARM9
//#define INT_TABLE_SECTION __attribute__((section(".sbss")))
//#else
#define INT_TABLE_SECTION
//#endif

IntFn _irqTableSimple[4] INT_TABLE_SECTION;

//---------------------------------------------------------------------------------
void _irqSet(int mask, IntFn handler) {
//---------------------------------------------------------------------------------
	if(mask==IRQ_TIMER2) _irqTableSimple[0]=handler;
	if(mask==IRQ_TIMER1) _irqTableSimple[1]=handler;
	if(mask==IRQ_VBLANK) _irqTableSimple[2]=handler;
	if(mask==IRQ_TIMER3) _irqTableSimple[3]=handler;
}

//---------------------------------------------------------------------------------
void _irqInit() {
//---------------------------------------------------------------------------------
	IRQ_HANDLER = _IntrMain;

	REG_IE	=	0;				// disable all interrupts
	REG_IF	=	IRQ_ALL;	// clear all pending interrupts
	REG_IME = 1;				// enable global interrupt

	_irqTableSimple[0]=_irqDummy;
	_irqTableSimple[1]=_irqDummy;
	_irqTableSimple[2]=_irqDummy;
	_irqTableSimple[3]=_irqDummy;
}

