unit MainWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,_PicTools, StdCtrls,_dpg_const,_dpgfs,_dosbox, ComCtrls,_m_Tools,dpgenc_language;

type
  TMain = class(TForm)
    IntervalTimer: TTimer;
    StartupTimer: TTimer;
    prgbar: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure IntervalTimerTimer(Sender: TObject);
    procedure StartupTimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
  public
    { Public 錾 }
    optReencWidth,optReencKBPS,optReencFPS:integer;
    procedure CheckFile;
    function StartEncode:boolean;
  end;

var
  Main: TMain;

procedure LoadLanguage(LanguageID:string);

implementation

uses DSSupportWin, OptionWin, enclogWin, encprvWin, OptionCmdLineWin;

{$R *.dfm}

var
  DPGINFO:TDPGINFO;

const CRLF:string=char($0d)+char($0a);

const BELOW_NORMAL_PRIORITY_CLASS=$00004000;
const ABOVE_NORMAL_PRIORITY_CLASS=$00008000;

procedure SetPriorityLevel(Level:integer);
begin
  case Level of
    0: SetPriorityClass(GetCurrentProcess,IDLE_PRIORITY_CLASS);
    1: SetPriorityClass(GetCurrentProcess,BELOW_NORMAL_PRIORITY_CLASS);
    2: SetPriorityClass(GetCurrentProcess,NORMAL_PRIORITY_CLASS);
    3: SetPriorityClass(GetCurrentProcess,ABOVE_NORMAL_PRIORITY_CLASS);
    4: SetPriorityClass(GetCurrentProcess,HIGH_PRIORITY_CLASS);
    5: SetPriorityClass(GetCurrentProcess,REALTIME_PRIORITY_CLASS);
    else SetPriorityClass(GetCurrentProcess,NORMAL_PRIORITY_CLASS);
  end;
end;

function isCheckOS:boolean;
var
  osverinfo:OSVERSIONINFO;
begin
  osverinfo.dwOSVersionInfoSize:=sizeof(OSVERSIONINFO);
  GetVersionEx(osverinfo);

  if osverinfo.dwPlatformId=VER_PLATFORM_WIN32_WINDOWS then begin
    Result:=False;
    end else begin
    Result:=True;
  end;

end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

var
  MasterFontCodepage:integer;
  MasterFontName:string;
  MasterFontSize:integer;

procedure ResetLanguageSet;
var
  res:integer;
  SearchRec: TSearchRec;
  fname:string;
  path:string;
begin
  Option.LanguageSetLst.Clear;

  path:=extractfilepath(Application.ExeName)+'dpgenclng\';

  res:=FindFirst(path+ChangeFileExt(extractfilename(Application.ExeName),'')+'.*.lng', (FaAnyFile), SearchRec);
  if res=0 then begin
    repeat
      fname:=SearchRec.Name;
      if (SearchRec.Attr and faDirectory)=0 then begin
        fname:=ChangeFileExt(fname,'');
        fname:=ExtractFileExt(fname);
        Option.LanguageSetLst.Items.Add(fname);
      end;
      res:=FindNext(SearchRec);
    until (res<>0);
  end;
  FindClose(SearchRec);
end;

procedure LoadLanguage(LanguageID:string);
var
  path:string;
  FontName:string;
  FontSize:integer;
  FontCodepage:integer;
  idx:integer;
  procedure SetFont(font:TFont);
  begin
    with font do begin
      Charset:=FontCodepage;
      Name:=FontName;
      Size:=FontSize;
      Charset:=FontCodepage;
    end;
  end;
begin
  path:=extractfilepath(Application.ExeName)+'dpgenclng\';

  LoadLngFile(path+ChangeFileExt(extractfilename(Application.ExeName),'')+LanguageID+'.lng');

  FontName:=lngID(LI_ID_FontName);
  if FontName='' then FontName:=MasterFontName;
  FontSize:=strtointdef(lngID(LI_ID_FontSize),MasterFontSize);
  FontCodepage:=strtointdef(lngID(LI_ID_FontCodepage),MasterFontCodepage);

  SetFont(Main.Font);
  SetFont(Option.Font);
  SetFont(OptionCmdLine.Font);
  SetFont(enclog.Font);

  with Option do begin
    SourceFilenameEdt.EditLabel.Caption:=lng(LI_FormSourceLabel);
    OpenBtn.Caption:=lng(LI_FormSelect);
    CancelBtn.Caption:=lng(LI_FormCancel);
    StartBtn.Caption:=lng(LI_FormStart);
    ExtendChk.Caption:=lng(LI_FormShowOptions);
    SoundGrp.Caption:=lng(LI_FormAudioOptions);
    SoundRateLbl.Caption:=lng(LI_FormAudioRate);
    SoundRateUnitLbl.Caption:=lng(LI_FormAudioRateUnit);
    SoundBPSLbl.Caption:=lng(LI_FormAudioBPS);
    SoundBPSUnitLbl.Caption:=lng(LI_FormAudioBPSUnit);
    SoundVolumeLbl.Caption:=lng(LI_FormAudioVolume);
    with SndGetModeLst do begin
      idx:=ItemIndex;
      Items[0]:=lng(LI_FormAudioGetModeItem0);
      Items[1]:=lng(LI_FormAudioGetModeItem1);
      Items[2]:=lng(LI_FormAudioGetModeItem2);
      Items[3]:=lng(LI_FormAudioGetModeItem3);
      Items[4]:=lng(LI_FormAudioGetModeItem4);
      ItemIndex:=idx;
    end;
    ReencEnabledChk.Caption:=lng(LI_FormVideoReencode);
    ReencOptGroup.Caption:=lng(LI_FormVideoOptions);
    VideoWidthLbl.Caption:=lng(LI_FormVideoWidth);
    VideoWidthUnitLbl.Caption:=lng(LI_FormVideoWidthUnit);
    with ReencAspectLst do begin
      idx:=ItemIndex;
      Items[0]:=lng(LI_FormVideoAspectItem0);
      Items[1]:=lng(LI_FormVideoAspectItem1);
      Items[2]:=lng(LI_FormVideoAspectItem2);
      Items[3]:=lng(LI_FormVideoAspectItem3);
      ItemIndex:=idx;
    end;
    VideoAspectLbl.Caption:=lng(LI_FormVideoAspect);
    VideoBPSLbl.Caption:=lng(LI_FormVideoBPS);
    VideoBPSUnitLbl.Caption:=lng(LI_FormVideoBPSUnit);
    VideoFPSLbl.Caption:=lng(LI_FormVideoFPS);
    VideoFPSUnitLbl.Caption:=lng(LI_FormVideoFPSUnit);
    VideoBrightLbl.Caption:=lng(LI_FormVideoBright);
    VideoBlurLbl.Caption:=lng(LI_FormVideoBlur);
    VideoBlurDeepLbl.Caption:=lng(LI_FormVideoBlurDeep);
    VideoBlurLightLbl.Caption:=lng(LI_FormVideoBlurLight);
    ReencVerticalSwapChk.Caption:=lng(LI_FormVideoFlip);
  end;
end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

const StoreBufSize=1*1024*1024;

procedure CreateDPG;
var
  wfs:TFileStream;
  ofspos:integer;
  posa,sizea:integer;
  posv,sizev:integer;
  function AddFile(ttl:string;fn:string):integer;
  var
    rfs:TFileStream;
    buf:array of byte;
    size:integer;
    idx:integer;
    bufsize:integer;
  begin
    Main.Caption:=ttl;

    setlength(buf,StoreBufSize);

    rfs:=TFileStream.Create(fn,fmOpenRead);
    size:=rfs.Size;
    if size<>0 then begin
      Main.prgbar.Position:=0;
      Main.prgbar.Max:=size div StoreBufSize;
      idx:=0;
      while(idx<size) do begin
        bufsize:=size-idx;
        if StoreBufSize<=bufsize then bufsize:=StoreBufSize;
        rfs.ReadBuffer(buf[0],bufsize);
        wfs.WriteBuffer(buf[0],bufsize);
        inc(idx,bufsize);

        Main.prgbar.Position:=idx div StoreBufSize;
      end;
      Main.prgbar.Position:=0;
    end;
    rfs.Free;

    Result:=size;
  end;
  procedure AddDW(dw:dword);
  begin
    wfs.WriteBuffer(dw,4);
  end;
  procedure padding32bit;
  var
    tmp:byte;
  begin
    tmp:=$00;
    if (wfs.Size mod 4)<>0 then wfs.WriteBuffer(tmp,1);
    if (wfs.Size mod 4)<>0 then wfs.WriteBuffer(tmp,1);
    if (wfs.Size mod 4)<>0 then wfs.WriteBuffer(tmp,1);
  end;
begin
  wfs:=TFileStream.Create(GetDPGFilename,fmCreate,fmShareExclusive);

  AddDW(DPGID);

  AddDW(DPGINFO.TotalFrame);
  AddDW(trunc(DPGINFO.FPS*$100));
  AddDW(DPGINFO.SndFreq);
  AddDW(DPGINFO.SndCh);

  ofspos:=wfs.Position;

  AddDW(0);
  AddDW(0);
  AddDW(0);
  AddDW(0);

  posa:=wfs.Position;

  sizea:=AddFile('Store Audio...',GetDPGMP2Filename);
  padding32bit();

  posv:=wfs.Position;
  sizev:=AddFile('Store Video...',GetDPGMovieFilename);
  padding32bit();

  wfs.Position:=ofspos;

  AddDW(posa);
  AddDW(sizea);
  AddDW(posv);
  AddDW(sizev);

  wfs.Free;
end;

procedure CreateNDSROM;
var
  wfs:TFileStream;
  function AddFile(ttl:string;fn:string):integer;
  var
    rfs:TFileStream;
    buf:array of byte;
    size:integer;
    idx:integer;
    bufsize:integer;
  begin
    Main.Caption:=ttl;

    setlength(buf,StoreBufSize);

    rfs:=TFileStream.Create(fn,fmOpenRead);
    size:=rfs.Size;
    if size<>0 then begin
      Main.prgbar.Position:=0;
      Main.prgbar.Max:=size div StoreBufSize;
      idx:=0;
      while(idx<size) do begin
        bufsize:=size-idx;
        if StoreBufSize<=bufsize then bufsize:=StoreBufSize;
        rfs.ReadBuffer(buf[0],bufsize);
        wfs.WriteBuffer(buf[0],bufsize);
        inc(idx,bufsize);

        Main.prgbar.Position:=idx div StoreBufSize;
      end;
      Main.prgbar.Position:=0;
    end;
    rfs.Free;

    Result:=size;
  end;
begin
  if FileExists(GetNDSROMFilename)=False then exit;

  wfs:=TFileStream.Create(GetNDSROMFilename,fmCreate,fmShareExclusive);

  AddFile('Marge NDSROM...',ExtractFilePath(Application.ExeName)+'dpgbaserom.nds');
  AddFile('Marge NDSROM...',GetDPGFilename);

  wfs.Free;
end;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

const SndGetMode_MEncoder=0;
const SndGetMode_FFMpeg=1;
const SndGetMode_ExtractWaveNormal=2;
const SndGetMode_ExtractWaveAlt=3;
const SndGetMode_External=4;

type
  TAudioInfo=record
    GetMode:integer;
    Volume:integer;
    Freq:integer;
    kbps:integer;
  end;

var
  AudioInfo:TAudioInfo;

type
  TVideoInfo=record
    ReEncode:boolean;
    Width,Height:integer;
    FPS:double;
    kbps:integer;
    Brightness:integer;
    Blur:integer;
    VerticalSwap:boolean;
    CmdLineFormat:string;
  end;

var
  VideoInfo:TVideoInfo;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

procedure TMain.FormCreate(Sender: TObject);
begin
  if isCheckOS=False then begin
    Application.Title:='windows version check.';
    ShowMessage('WindowsNTn(Win2000/XP)OSłNł܂B'+CRLF+CRLF+'The tool related to DPG works only in the WindowsNT system. (Win2k/WinXP etc.)');
    Application.Terminate;
    exit;
  end;

  setlog;

  SetBaseFilename('','');

  StartupTimer.Enabled:=True;
end;

procedure TMain.CheckFile;
var
  msg:string;
begin
  if (256<VideoInfo.Width) or (192<VideoInfo.Height) then begin
    ShowMessage(lng(LI_DirectMpegVideoSizeError));
    Application.Terminate;
    exit;
  end;

  if 24<=VideoInfo.FPS then begin
    msg:=format(lng(LI_AboutFrameRate),[VideoInfo.FPS]);
    if MessageDlg(msg,mtInformation,[mbYes,mbCancel],0)=mrCancel then begin
      Application.Terminate;
      exit;
    end;
  end;
end;

procedure TMain.StartupTimerTimer(Sender: TObject);
var
  lx,ly:integer;
  Aspect:double;
  SourceFPS:double;
begin
  StartupTimer.Enabled:=False;

  Application.Title:='nDs-mPeG encoder / dpgenc option';
//  Application.Title:='Language test';

  MasterFontCodepage:=Main.Font.Charset;
  MasterFontName:=Main.Font.Name;
  MasterFontSize:=Main.Font.Size;

  Main.Caption:=Application.Title;
  Option.Caption:=Application.Title;

  lx:=Main.Left;
  ly:=Main.Top;
  Main.Left:=-Main.Width;
  Main.Top:=-Main.Top;
  Main.ClientWidth:=prgbar.Width;
  Main.ClientHeight:=prgbar.Height;

  ResetLanguageSet;
  Option.LanguageSetLst.ItemIndex:=0;

  Option.DirectFilename:='';
  if ParamCount=1 then begin
    if FileExists(ParamStr(1))=True then begin
      Option.DirectFilename:=ParamStr(1);
    end;
  end;

  if Option.ShowModal=mrCancel then begin
    Application.Terminate;
    exit;
  end;

  if fileexists(Option.SourceFilenameEdt.Text)=False then application.Terminate;

  SetBaseFilename(Option.SourceFilenameEdt.Text,Option.DPGFilename);

  DSSupport.DSOpen(GetAVIFilename,0,0,0);
  SourceFPS:=DSSupport.GetSourceFPS;
  DSSupport.DSClose;

  with AudioInfo do begin
    Volume:=Option.SndVolumeBar.Position;
    GetMode:=Option.SndGetModeLst.ItemIndex;
    Freq:=strtoint(Option.SndFreqLst.Text);
    kbps:=strtoint(Option.SndKBPSLst.Text);
  end;

  if (DSSupport.VideoWidth=0) or (DSSupport.VideoHeight=0) then begin
    ShowMessage(lng(LI_DetectErrorVideoSize));
    Application.Terminate;
    exit;
  end;

  if DSSupport.DSTotalTime=0 then begin
    ShowMessage(lng(LI_DetectErrorTotalTime));
    Application.Terminate;
    exit;
  end;

  if Option.ReencEnabledChk.Checked=False then begin
    with VideoInfo do begin
      ReEncode:=False;
      Width:=DSSupport.VideoWidth;
      Height:=DSSupport.VideoHeight;
      FPS:=SourceFPS;
      kbps:=0;
      Brightness:=0;
      VerticalSwap:=False;
      CmdLineFormat:='';
    end;
    end else begin
    with VideoInfo do begin
      ReEncode:=True;

      Width:=strtoint(Option.ReencWidthLst.Text);
      Width:=(Width div 16)*16;
      if 256<Width then Width:=256;

      case Option.ReencAspectLst.ItemIndex of
        0: Aspect:=DSSupport.VideoHeight/DSSupport.VideoWidth;
        1: Aspect:=3/4;
        2: Aspect:=9/16;
        3: Aspect:=1/2.35;
        else Aspect:=0;
      end;
      if Aspect=0 then begin
        ShowMessage(lng(LI_DetectErrorIlligalAspect));
        Application.Terminate;
        exit;
      end;

      Height:=trunc(Width*Aspect);
      Height:=(Height div 16)*16;
      if 192<Height then Height:=192;

      FPS:=strtoint(Option.ReencFPSLst.Text);
      kbps:=strtoint(Option.ReencKBPSLst.Text);
      Brightness:=Option.ReencBrightnessBar.Position;
      Blur:=Option.ReencBlurBar.Position;
      VerticalSwap:=Option.ReencVerticalSwapChk.Checked;
      CmdLineFormat:=Option.ReencCmdLineEdt.Text;
    end;
  end;

  with DPGINFO do begin
    FPS:=VideoInfo.FPS;
    TotalFrame:=trunc(DSSupport.DSTotalTime*FPS);
    SndFreq:=AudioInfo.Freq;
    SndCh:=0;
  end;

  CheckFile;

  Main.Left:=lx;
  Main.Top:=ly;

  IntervalTimer.Enabled:=True;
end;

procedure EncodeGSM(srcfn:string;dstfn:string;freq:integer);
var
  StartPath:string;
  appfn:string;
  tmpfn:string;
begin
  if FileExists(srcfn)=False then begin
    ShowMessage(srcfn+' not found.');
    Application.Terminate;
    exit;
  end;

  StartPath:=extractfilepath(Application.ExeName);
  appfn:=StartPath+'\dpgencplugin\sox.exe';

  if fileexists(appfn)=False then begin
    ShowMessage('file not found. '+appfn);
    Application.Terminate;
    exit;
  end;

  tmpfn:=GetTempFilename;

  Main.Caption:='Encode Wave to GSM...';
  CreateDOSBOX(StartPath,'"'+appfn+'" -V -twav "'+srcfn+'" -v'+format('%4.2f',[AudioInfo.Volume/100])+' -r'+inttostr(freq)+' -tgsm -c1 "'+tmpfn+'"');
  Main.Caption:='Create GSM file...';
  CreateDOSBOX(StartPath,'"'+appfn+'" -V -r'+inttostr(freq)+' -tgsm "'+tmpfn+'" -twav "'+dstfn+'"');

  DeleteFile(tmpfn);
end;

procedure EncodeMP2(srcfn,dstfn:string;freq:integer;kbps:integer);
var
  StartPath:string;
  appfn:string;
begin
  if FileExists(srcfn)=False then begin
    ShowMessage(srcfn+' not found.');
    Application.Terminate;
    exit;
  end;

  StartPath:=extractfilepath(Application.ExeName);
  appfn:=StartPath+'\dpgencplugin\ffmpeg.exe';

  if fileexists(appfn)=False then begin
    ShowMessage('file not found. '+appfn);
    Application.Terminate;
    exit;
  end;

  Main.Caption:='Encode Wave to MP2...';
  CreateDOSBOX(StartPath,format('"'+appfn+'" -i "'+srcfn+'" -acodec mp2 -ab %d -ar %d "'+dstfn+'"',[kbps,freq]));
end;

procedure DemuxAudio(avifn:string;wavfn:string;altmode:boolean);
var
  StartPath:string;
  appfn:string;
  cmdline:string;
begin
  if AudioInfo.GetMode=SndGetMode_External then exit;

  StartPath:=extractfilepath(Application.ExeName);
  appfn:=StartPath+'\dpgencplugin\extractwave.exe';

  if fileexists(appfn)=False then begin
    ShowMessage('file not found. '+appfn);
    Application.Terminate;
    exit;
  end;

  cmdline:='"'+appfn+'" "'+avifn+'" "'+wavfn+'"';
  if altmode=True then cmdline:=cmdline+' -A';

  CreateDOSBOX(StartPath,cmdline);
end;

procedure DirectEncodeMP2_MEncoder(srcfn,dstfn:string;freq:integer;kbps:integer);
var
  StartPath:string;
  appfn:string;
  cmdline:string;
begin
  if FileExists(srcfn)=False then begin
    ShowMessage(srcfn+' not found.');
    Application.Terminate;
    exit;
  end;

  StartPath:=extractfilepath(Application.ExeName);
  appfn:=StartPath+'\dpgencplugin\mencoder.exe';

  if fileexists(appfn)=False then begin
    ShowMessage('file not found. '+appfn);
    Application.Terminate;
    exit;
  end;

  Main.Caption:='Encode Wave to MP2...';
  cmdline:=format('-noautosub -ovc copy -oac lavc -lavcopts acodec=mp2:abitrate=%d -af resample=%d:1:2 -of rawaudio',[kbps,freq]);
  CreateDOSBOX(StartPath,'"'+appfn+'" -v "'+srcfn+'" '+cmdline+' -o "'+dstfn+'"');
end;

procedure DirectEncodeMP2_FFMpeg(srcfn,dstfn:string;freq:integer;kbps:integer);
var
  StartPath:string;
  appfn:string;
  cmdline:string;
begin
  if FileExists(srcfn)=False then begin
    ShowMessage(srcfn+' not found.');
    Application.Terminate;
    exit;
  end;

  StartPath:=extractfilepath(Application.ExeName);
  appfn:=StartPath+'\dpgencplugin\ffmpeg.exe';

  if fileexists(appfn)=False then begin
    ShowMessage('file not found. '+appfn);
    Application.Terminate;
    exit;
  end;

  Main.Caption:='Encode Wave to MP2...';
  cmdline:=format('-acodec mp2 -ab %d -ar %d',[kbps,freq]);
  CreateDOSBOX(StartPath,'"'+appfn+'" -i "'+srcfn+'" '+cmdline+' "'+dstfn+'"');
end;

procedure DemuxVideo(avifn:string;m1vfn:string);
var
  StartPath:string;
  appfn:string;
begin
  StartPath:=extractfilepath(Application.ExeName);
  appfn:=StartPath+'\dpgencplugin\extract_mpeg2.exe';

  if fileexists(appfn)=False then begin
    ShowMessage('file not found. '+appfn);
    Application.Terminate;
    exit;
  end;

  CreateDOSBOX(StartPath,'"'+appfn+'" -s 0xe0 "'+avifn+'" > "'+m1vfn+'"');
end;

procedure EncodeVideo(avifn:string;m1vfn:string);
var
  hInputRead,hInputWrite:THANDLE;
  hOutputRead,hOutputWrite:THANDLE;
  FrameIdx:integer;
  w,h:integer;
  bm,lastbm:TBitmap;
  ErrorStr:string;
  readsize:dword;
  PipeBufStr:string;
  PipeBufFlag:boolean;
  lasttick:dword;
  CaptionText:string;
  function CreatePipes(ReadBufSize:dword):boolean;
  var
    SA:SECURITY_ATTRIBUTES;
    SD:TSecurityDescriptor;
  begin
    sa.nLength:=sizeof(SECURITY_ATTRIBUTES);
    sa.lpSecurityDescriptor:=nil;
    sa.bInheritHandle:=True;
    InitializeSecurityDescriptor(@SD,SECURITY_DESCRIPTOR_REVISION);
    SetSecurityDescriptorDacl(@SD,True,nil,False);
    sa.lpSecurityDescriptor:=@SD;

    if CreatePipe(hInputRead,hInputWrite,@sa,ReadBufSize)=False then begin
      ShowMessage(lng(LI_PipeErrorCreate));
      Result:=False;
      exit;
    end;
    if DuplicateHandle(GetCurrentProcess(),hInputWrite,GetCurrentProcess(),nil,0,False,DUPLICATE_SAME_ACCESS)=False then begin
      ShowMessage(lng(LI_PipeErrorAttribute));
      Result:=False;
      exit;
    end;

    if CreatePipe(hOutputRead,hOutputWrite,@sa,0)=False then begin
      ShowMessage(lng(LI_PipeErrorCreate));
      Result:=False;
      exit;
    end;
    if DuplicateHandle(GetCurrentProcess(),hOutputRead,GetCurrentProcess(),nil,0,False,DUPLICATE_SAME_ACCESS)=False then begin
      ShowMessage(lng(LI_PipeErrorAttribute));
      Result:=False;
      exit;
    end;

    Result:=True;
  end;
  function StartEncode(w,h:integer;fps:double;frames,kbps:integer):boolean;
  var
    StartPath:string;
    appfn:string;
    cmdline:string;
    fixkbps:integer;
  begin
    Result:=False;

    StartPath:=extractfilepath(Application.ExeName);
    appfn:=StartPath+'dpgencplugin\mencoder.exe';

    if fileexists(appfn)=False then begin
      ShowMessage('file not found. '+appfn);
      Application.Terminate;
      exit;
    end;

    if CreatePipes(w*3*h)=False then exit;

    fixkbps:=trunc(kbps*24/fps);
    cmdline:=format(VideoInfo.CmdLineFormat,[frames,w,h,w*3*h,fixkbps]);
    cmdline:='"'+appfn+'" -v - -o "'+m1vfn+'" '+cmdline;
    enclog.loglst.Lines.Add(cmdline);
    enclog.loglst.Lines.Add('');

    if CreateDOSBOX2(StartPath,hInputRead,hOutputWrite,hOutputWrite,cmdline)=False then begin
      ShowMessage('CreateDOSBOX error.');
      exit;
    end;

    Result:=True;
  end;
  function ReadPipe(hnd:THANDLE):string;
  var
    ansistr:array[0..1024] of ansichar;
    i:integer;
    len:dword;
    readsize:dword;
    c:ansichar;
  begin
    Result:='';

    len:=0;
    if PeekNamedPipe(hnd, nil, 0, nil,@len,nil)=True then begin
      if len<>0 then begin
        if 1024<=len then len:=1024;
        if ReadFile(hnd,ansistr[0],len,readsize,nil)=True then begin
          for i:=0 to readsize-1 do begin
            c:=ansistr[i];
            if PipeBufFlag=False then begin
              if c=ansichar($0d) then begin
                PipeBufFlag:=True;
                end else begin
                PipeBufStr:=PipeBufStr+c;
              end;
              end else begin
              PipeBufFlag:=False;
              if c=ansichar($0a) then begin
                Result:=Result+PipeBufStr+CRLF;
                PipeBufStr:='';
                end else begin
                CaptionText:=PipeBufStr;
                PipeBufStr:=c;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  procedure EndEncode;
  begin
    CloseDOSBOX2;

    ErrorStr:=ReadPipe(hOutputRead);
    if ErrorStr<>'' then begin
      enclog.loglst.Lines.Add(ErrorStr);
      enclog.loglst.Refresh;
    end;
    enclog.loglst.Lines.SaveToFile(changefileext(Application.ExeName,'')+'_mencoder.log');

    CloseHandle(hInputWrite);
    CloseHandle(hOutputRead);
  end;
  procedure BrightnessEffect(var bm:TBitmap;Brightness:integer);
  var
    br:integer;
    pb:PByteArray;
    y,x:integer;
    c:integer;
  begin
    if Brightness=100 then exit;
    br:=(Brightness*$100) div 100;
    for y:=0 to bm.Height-1 do begin
      pb:=bm.ScanLine[y];
      for x:=0 to bm.Width*3-1 do begin
        c:=pb[x];
        c:=(c*br) div $100;
        if c<=$ff then begin
          pb[x]:=c;
          end else begin
          pb[x]:=$ff;
        end;
      end;
    end;
  end;
  procedure Blur(var lastbm,bm:TBitmap;percent:integer);
  var
    lastper,per:integer;
    lastpb,pb:PByteArray;
    y,x:integer;
    lastc,c,dstc:integer;
  begin
    if percent=100 then exit;
    lastper:=((100-percent)*$100) div 100;
    per:=(percent*$100) div 100;
    for y:=0 to bm.Height-1 do begin
      lastpb:=lastbm.ScanLine[y];
      pb:=bm.ScanLine[y];
      for x:=0 to bm.Width*3-1 do begin
        lastc:=lastpb[x]*lastper;
        c:=pb[x]*per;
        dstc:=(lastc+c) div $100;
        if $ff<dstc then dstc:=$ff;
        pb[x]:=dstc;
      end;
    end;
  end;
  procedure SendRAW(var bm:TBitmap;w,h:integer);
  var
    pb:PByteArray;
    y:integer;
    buf:array of byte;
  begin
    setlength(buf,w*3*h);
    for y:=0 to h-1 do begin
      pb:=bm.ScanLine[y];
      CopyMemory(@buf[w*3*y],@pb[0],w*3);
    end;
    WriteFile(hInputWrite,buf[0],w*3*h,readsize,nil);
  end;
begin
  with VideoInfo do begin
    w:=Width;
    h:=Height;
    if StartEncode(w,h,FPS,DPGINFO.TotalFrame,kbps)=False then exit;
  end;

  CloseHandle(hInputRead);
  CloseHandle(hOutputWrite);

  DSSupport.DSOpen(GetAVIFilename,VideoInfo.FPS,0,0);

  bm:=TBitmap.Create;
  MakeBlankBM(bm,w,h,pf24bit);
  lastbm:=TBitmap.Create;
  MakeBlankBM(lastbm,w,h,pf24bit);

  main.prgbar.Position:=0;
  main.prgbar.Max:=DPGINFO.TotalFrame;

  with Main do begin
    encprv.Top:=Top;
    encprv.Left:=Left+Width;
    encprv.ClientWidth:=w;
    encprv.ClientHeight:=h;
  end;
  encprv.Visible:=True;

  with Main do begin
    enclog.Top:=Top+Height;
    enclog.Left:=Left;
    enclog.Width:=Width;
  end;
  enclog.Visible:=True;

  PipeBufStr:='';
  PipeBufFlag:=False;
  CaptionText:='';

  lasttick:=GetTickCount-500;

  for FrameIdx:=0 to DPGINFO.TotalFrame-1 do begin
    main.prgbar.Position:=FrameIdx;
    bitblt(lastbm.Canvas.Handle,0,0,w,h,bm.Canvas.Handle,0,0,SRCCOPY);
    DSSupport.GetStretchBitmap(FrameIdx,bm,VideoInfo.VerticalSwap);
    BrightnessEffect(bm,VideoInfo.Brightness);
    Blur(lastbm,bm,VideoInfo.Blur);

    if 250<=(GetTickCount-lasttick) then begin
      lasttick:=GetTickCount;
      BitBlt(encprv.Canvas.Handle,0,0,w,h,bm.Canvas.Handle,0,0,SRCCOPY);
      if CaptionText<>'' then begin
        enclog.Caption:=CaptionText;
        CaptionText:='';
      end;
    end;

    SendRAW(bm,w,h);

    ErrorStr:=ReadPipe(hOutputRead);
    if ErrorStr<>'' then begin
      enclog.loglst.Lines.Add(ErrorStr);
      enclog.loglst.Refresh;
    end;

    Application.ProcessMessages;
  end;

  bm.Free;
  DSSupport.DSClose;

  EndEncode;

  enclog.Caption:='terminated.';
end;

function TMain.StartEncode:boolean;
begin
  Main.Caption:='Demultiplex AudioStream...';

  case AudioInfo.GetMode of
    SndGetMode_MEncoder: begin
      DirectEncodeMP2_MEncoder(GetAVIFilename,GetDPGMP2Filename,DPGINFO.SndFreq,AudioInfo.kbps);
    end;
    SndGetMode_ExtractWaveNormal: begin
      DemuxAudio(GetAVIFilename,GetDPGWaveFilename,False);
      EncodeMP2(GetDPGWaveFilename,GetDPGMP2Filename,DPGINFO.SndFreq,AudioInfo.kbps);
    end;
    SndGetMode_ExtractWaveAlt: begin
      DemuxAudio(GetAVIFilename,GetDPGWaveFilename,True);
      EncodeMP2(GetDPGWaveFilename,GetDPGMP2Filename,DPGINFO.SndFreq,AudioInfo.kbps);
    end;
    SndGetMode_FFMpeg: begin
      DirectEncodeMP2_FFMpeg(GetAVIFilename,GetDPGMP2Filename,DPGINFO.SndFreq,AudioInfo.kbps);
    end;
    SndGetMode_External: begin
      EncodeMP2(GetExternalWaveFilename,GetDPGMP2Filename,DPGINFO.SndFreq,AudioInfo.kbps);
    end;
  end;

  if (FileExists(GetDPGMP2Filename)=False) or (GetFileSize(GetDPGMP2Filename)<1024) then begin
    ShowMessage(lng(LI_GetAudioError));
    Result:=False;
    exit;
  end;

  if VideoInfo.ReEncode=False then begin
    Main.Caption:='Demultiplex VideoStream...';
    DemuxVideo(GetAVIFilename,GetDPGMovieFilename);
    end else begin
    Main.Caption:='Encode VideoStream...';
    EncodeVideo(GetAVIFilename,GetDPGMovieFilename);
  end;

  Result:=True;
  Main.Caption:='';
end;

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

// ------------------------------------------------------------
// ------------------------------------------------------------

procedure TMain.IntervalTimerTimer(Sender: TObject);
begin
  SetPriorityLevel(1);

  IntervalTimer.Enabled:=False;
  BaseCanClose:=False;

  if StartEncode=False then begin
    Application.Terminate;
    exit;
  end;

  CreateDPG;
  CreateNDSROM;

  if FileExists(GetDPGMovieFilename)=True then DeleteFile(GetDPGMovieFilename);
  if FileExists(GetDPGWaveFilename)=True then DeleteFile(GetDPGWaveFilename);
  if FileExists(GetDPGMP2Filename)=True then DeleteFile(GetDPGMP2Filename);
  if FileExists(GetTempFilename)=True then DeleteFile(GetTempFilename);

  if ParamCount<>1 then begin
    ShowMessage('Encode was completed.'+CRLF+CRLF+LoadDPGINFOString(GetDPGFilename));
  end;

  BaseCanClose:=True;

  Main.Close;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IntervalTimer.Enabled=True then begin
    IntervalTimer.Enabled:=False;
    if MessageDlg('𒆒f܂H'+CRLF+'stop encording?',mtWarning,[mbYes,mbNo],0)=mrNo then begin
      Action:=caNone;
      IntervalTimer.Enabled:=True;
      exit;
    end;
  end;

  DSSupport.DSClose;
end;

procedure TMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if BaseCanClose=False then CanClose:=False;
end;

procedure TMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then Main.Close;
end;

end.


